=== debian/changelog ===
flang (20190329-5) unstable; urgency=medium

  * Override dh_dwz as it FTBFS. Closes: #950594

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 04 Feb 2020 09:31:51 +0000

flang (20190329-4) unstable; urgency=medium

  * Now flang Provides: flang-mod-34 for dh-fortran-mod >= 0.14
  * Standards-Version: 4.4.1.0
  * Add debian/gbp.conf

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 10 Oct 2019 16:49:11 +0100

flang (20190329-3) unstable; urgency=medium

  * Use debhelper-compat (= 12)
  * Patch for FTBFS with g++-9 from Gianfranco Costamagna. Closes: #925682

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 15 Aug 2019 09:06:22 +0100

flang (20190329-2) unstable; urgency=medium

  * Drop comments that cause failures in postinst. Closes: #924090
  * B-D on dh-fortran-mod (>= 0.13) for flang-mod-34 support.
    Closes: #931106, #930628
  * Standards-Version: 4.4.0

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 18 Jul 2019 12:12:13 +0100

flang (20190329-1) unstable; urgency=medium

  * New upstream release
  * Debhelper 12

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 26 Apr 2019 15:13:59 +0100

flang (20181226-5) experimental; urgency=medium

  * Typo: space in postinst.in. Closes: #924090
  * Add libdir.patch to add $LIBDIR/fortran/flang-7 to search path
  * add #DEBHELPER# tag to flang-7.prerm

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 23 Apr 2019 14:40:13 +0100

flang (20181226-4) experimental; urgency=medium

  * Add "flibdir" $LIBDIR/fortran/default -> $LIBDIR/fortran/{flang-7,gfortran}
    as a slave to f95 alternatives; flang-7 compiled libs installed in $flibdir

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 08 Mar 2019 09:45:07 +0000

flang (20181226-3) experimental; urgency=medium

  * flang-7 now provides: flang
  * Add libomp-7-dev as dependency for flang-7. 
  * preprocessor-spaces.patch: Avoid spaces before preprocessor directives;
    breaks flang.
  * ice-on-gcc8.patch: Fix for ICE on some architectures in libpgmath code

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 23 Feb 2019 10:25:47 +0000
