=== debian/control ===
Source: flang
Section: devel
Priority: optional
Maintainer: LLVM Packaging Team <pkg-llvm-team@lists.alioth.debian.org>
Uploaders: Alastair McKinstry <mckinstry@debian.org>
Build-Depends:  debhelper-compat (= 12),
  dh-fortran-mod (>= 0.13),
  chrpath,
  gawk,
  zlib1g-dev,
  cmake,
  llvm-7,
  llvm-7-dev,
  libomp-7-dev,
  llvm-7-tools,
  gfortran
Standards-Version: 4.4.1.0
Homepage: https://github.com/flang-compiler/flang
Vcs-Browser: https://salsa.debian.org/mckinstry/flang.git
Vcs-Git: https://salsa.debian.org/mckinstry/flang.git

Package: flang-7
Architecture: any
Provides: fortran-compiler, flang, flang-mod-34
Depends: ${misc:Depends}, ${shlibs:Depends}, libflang0d-7 ( = ${binary:Version}), 
 libflang-dev ( = ${binary:Version}),
 libomp-7-dev
Description: Fortran compiler front-end for LLVM
 This is a Fortran compiler using LLVM.

Package: libflang0d-7
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Runtime libraries for the flang Fortran compiler
 Flang is a Fortran compiler for the LLVM toolchain.
 .
 This provides the flang runtime libraries.

Package: libflang-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, libflang0d-7 (= ${binary:Version})
Description: flang library - Development package.
 Flang is a Fortran compiler for the LLVM toolchain.
 .
 This provides the static libraries and headers for Extension writing.
