=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

# UPSTREAM_VERSION=20181226

BUILDDIR=$(CURDIR)/debian/build
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
LIBDIR=/usr/lib/$(DEB_HOST_MULTIARCH)
AUTOGENERATED:= libflang-dev.install libflang0d-7.install flang-7.install flang-7.postinst

%:
	dh $@ --buildsystem=cmake  --with=fortran_mod --builddirectory=$(BUILDDIR)

override_dh_auto_clean:
	dh_clean
	rm -rf $(BUILDDIR)
	rm -f $(patsubst %, debian/%, ${AUTOGENERATED})

override_dh_auto_configure:
	for f in ${AUTOGENERATED} ; do \
                sed -e 's%@ARCH@%${DEB_HOST_MULTIARCH}%g' < debian/$$f.in  > debian/$$f ; \
                done
	# Configuration and build are interleaved, so no configure here
	mkdir -p $(BUILDDIR)/runtime/libpgmath $(BUILDDIR)/flang-driver $(BUILDDIR)/stage2
	# Bug in install CMake code. Need these
	mkdir -p $(BUILDDIR)/include $(BUILDDIR)/stage2/include

override_dh_auto_build:
	(cd $(BUILDDIR)/runtime/libpgmath && cmake \
	    -DCMAKE_INSTALL_PREFIX=/usr \
	    -DLIBPGMATH_LLVM_LIT_EXECUTABLE=/usr/lib/llvm-7/build/utils/lit/lit.py \
	    ../../../../runtime/libpgmath && \
	    $(MAKE) VERBOSE=1 install DESTDIR=$(CURDIR)/debian/tmp )
	( cd $(BUILDDIR)/flang-driver && cmake \
	    -DCMAKE_INSTALL_PREFIX=/usr \
	    -DLINK_POLLY_INTO_TOOLS=False \
	    -DLLVM_CONFIG=/usr/lib/llvm-7/bin/llvm-config \
	    ../../../flang-driver &&  \
	    $(MAKE) VERBOSE=1 DESTDIR=$(CURDIR)/debian/tmp )
	# Stage 1. Built with gfortran
	(cd $(BUILDDIR) && cmake \
	    -DCMAKE_INSTALL_PREFIX=/usr \
	    -DCMAKE_Fortran_COMPILER=/usr/bin/gfortran \
	    -DCMAKE_Fortran_COMPILER_ID=gfortran \
	    -DLLVM_CONFIG=/usr/lib/llvm-7/bin/llvm-config \
	    -DFLANG_LIBOMP=$(LIBDIR)/libomp5.so	\
	    -DLIBPGMATH=$(CURDIR)/debian/tmp/usr/lib/libpgmath.so \
	    ../.. && \
	    $(MAKE) VERBOSE=1 DESTDIR=$(CURDIR)/debian/tmp-stage1 )
	# Stage 2. Built with flang
	(cd $(BUILDDIR)/stage2 && PATH=$(BUILDDIR)/debian/build/bin:$(PATH) cmake \
	    -DCMAKE_INSTALL_PREFIX=/usr \
	    -DCMAKE_Fortran_COMPILER=$(BUILDDIR)/flang-driver/bin/flang \
	    -DCMAKE_Fortran_COMPILER_ID=flang \
	    -DLLVM_CONFIG=/usr/lib/llvm-7/bin/llvm-config \
	    -DFLANG_LIBOMP=$(LIBDIR)/libomp5.so	\
	    -DLIBPGMATH=$(CURDIR)/debian/tmp/usr/lib/libpgmath.so \
	    ../../.. && \
	    $(MAKE) VERBOSE=1 DESTDIR=$(CURDIR)/debian/tmp )

override_dh_auto_install:
	dh_auto_install --builddirectory=$(BUILDDIR)/runtime/libpgmath
	# Do in install scripts; fails within pdebuild, why ?
	( cd debian/build/stage2 && make VERBOSE=1 install DESTDIR=$(CURDIR)/debian/tmp )
	chrpath -d debian/tmp/usr/lib/*.so*
	cp -L $(BUILDDIR)/flang-driver/bin/clang-7 debian/tmp/usr/bin/flang-7
	chrpath -d debian/tmp/usr/bin/flang*

override_dh_dwz:
	@echo DWZ bypassed in this build. See #950594
